# Elevate
# Copyright 2007 Jeff Armstrong (jba@member.fsf.org) 
# 
# This program is free software; you can redistribute it and/or modify 
# it under the terms of the GNU General Public License as published by 
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version. 
#  
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to:
# Free Software Foundation, Inc.
# 51 Franklin Street, Fifth Floor
# Boston, MA  02110-1301, USA

from data import *
from constants import *
from floor import *

LEVEL_FILE = 'levels.txt'

def updateFloors(levels,floors):
    for i in range(0,NUMBER_FLOORS):
        floors[i].setProbability(levels.getProbability(i))

class LevelHandler:
    def __init__(self):
        self.names = []
        self.threshhold = []
        self.probabilities = []
        self.goodbyes = []
        self.current = 0
        self.changed = True
    
    def load(self):
        instream = open(filepath(LEVEL_FILE),"r")
        n_levels = int(instream.readline())
        
        for i in range(0,n_levels):
            self.names.append(instream.readline().strip())
            self.goodbyes.append(instream.readline().strip())
            self.threshhold.append(int(instream.readline()))
            probs = []
            for i in range(0,NUMBER_FLOORS):
                one_line = instream.readline().strip()
                entries = one_line.split(',')
                probs.append(float(entries[1]))
            self.probabilities.append(probs)
                
        instream.close()
    
    def isChanged(self):
        buffer = self.changed
        self.changed = False
        return buffer
        
    def checkLevel(self,delivered):
        if self.current == len(self.names)-1:
            return
        if delivered > self.threshhold[self.current+1]:
            self.current = self.current+1
            self.changed = True
            
    def getGoodbye(self):
        return self.goodbyes[self.current]
    
    def getTitle(self):
        return self.names[self.current]
    
    def getProbability(self,floor):
        probs = self.probabilities[self.current]
        return probs[floor]
    
    