# Elevate
# Copyright 2007 Jeff Armstrong (jba@member.fsf.org) 
# 
# This program is free software; you can redistribute it and/or modify 
# it under the terms of the GNU General Public License as published by 
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version. 
#  
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to:
# Free Software Foundation, Inc.
# 51 Franklin Street, Fifth Floor
# Boston, MA  02110-1301, USA

import pygame
from data import *
from screen import *

LOSER_FONT_NAME = "CAB.TTF"

class LoserPanel(pygame.sprite.Sprite):
    
    def __init__(self, delivered):
        pygame.sprite.Sprite.__init__(self)
        self.rect = Rect(0,0,0,0)
        self.bkgdcolor = Color('White')
        self.font = pygame.font.Font(filepath(LOSER_FONT_NAME),60)
        self.fired_font = pygame.font.Font(filepath(LOSER_FONT_NAME),100)
        self.cont_font = pygame.font.Font(filepath(LOSER_FONT_NAME),25)
        self.message = 'None...'
        self.updatenow = True
    
    def setMessage(self,value):
        self.message = value
        self.updatenow = True
        
    def drawSlip(self):
        #points = []
        #points.append((self.rect.width/3,self.rect.height/4))
        #points.append((self.rect.width/3,3*self.rect.height/4))
        #points.append((2*self.rect.width/3,2*self.rect.height/3))
        #points.append((2*self.rect.width/3,1*self.rect.height/3))
        #pygame.draw.polygon(self.image,Color('Pink'),points,0)
        #pygame.draw.polygon(self.image,Color('Black'),points,4)
        
        slip = Rect(self.rect.width/4,self.rect.height/4,self.rect.width/2,self.rect.height/2)
        pygame.draw.rect(self.image,Color('Pink'),slip,0)
        pygame.draw.rect(self.image,Color('Black'),slip,4)
        
        fired_text = self.fired_font.render('FIRED!',1,Color('Black'))
        self.image.blit(fired_text,(int(1.1*self.rect.width/4),int(1.1*self.rect.height/4)))
        
        
        for j in range(self.rect.height/2,int(self.rect.height-1.1*self.rect.height/4),30):
            points = []
            for i in range(int(1.1*self.rect.width/4),int(self.rect.width-1.2*self.rect.width/4),50):
                points.append((i,j-25))
                points.append((i+25,j))
        
            pygame.draw.lines(self.image,Color('Black'),False,points,4)

    def drawText(self):
        complaints = self.font.render('Too Many Complaints...',1,Color('Black'))
        self.image.blit(complaints,((self.rect.width-complaints.get_width())/2,self.rect.height/8-complaints.get_height()/2))
        
        message_text = self.font.render(self.message,1,Color('Black'))
        self.image.blit(message_text,((self.rect.width-message_text.get_width())/2,7*self.rect.height/8-message_text.get_height()/2))
        
        continue_text = self.cont_font.render('Press SPACE to continue...',1,Color('Red'))
        self.image.blit(continue_text,(self.rect.width/20,self.rect.height-continue_text.get_height()))
        
    def updateRect(self):
        self.rect = Rect(0,0,int(getScaling()*BASE_WIDTH),int(getScaling()*BASE_HEIGHT))

    def update(self):
        scale = getScaling()
        if self.rect.width != int(scale*BASE_WIDTH) or self.updatenow:
            self.updateRect()
            self.image = Surface((self.rect.width,self.rect.height))
            self.image.convert_alpha()
            self.image.fill(self.bkgdcolor)
            self.image.set_alpha(164)
            self.drawSlip()
            self.drawText()
            self.updatenow = False
 