# Elevate
# Copyright 2007 Jeff Armstrong (jba@member.fsf.org) 
# 
# This program is free software; you can redistribute it and/or modify 
# it under the terms of the GNU General Public License as published by 
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version. 
#  
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to:
# Free Software Foundation, Inc.
# 51 Franklin Street, Fifth Floor
# Boston, MA  02110-1301, USA

import pygame
from data import *
from screen import *
from constants import *

MAN_FONT_NAME = "CAB.TTF"

MAN_FILENAME = 'manual.txt'

REPLACE_MAX_TAG = '##MAX'

class Manual(pygame.sprite.Sprite):
    
    def __init__(self):
        pygame.sprite.Sprite.__init__(self)
        self.rect = Rect(0,0,0,0)
        self.bkgdcolor = Color('White')
        self.font = pygame.font.Font(filepath(MAN_FONT_NAME),30)
        self.cont_font = pygame.font.Font(filepath(MAN_FONT_NAME),25)
    
    def updateRect(self):
        self.rect = Rect(0,0,int(getScaling()*BASE_WIDTH),int(getScaling()*BASE_HEIGHT))

    def drawText(self):
        instream = open(filepath(MAN_FILENAME),"r")
        num_lines = int(instream.readline().strip())
        
        for i in range(0,num_lines):
            text_line = instream.readline().rstrip()
            text_line = text_line.replace(REPLACE_MAX_TAG,str(MAX_COMPLAINTS))
            one_line = self.font.render(text_line,1,Color('Black'))
            self.image.blit(one_line,(10,20+i*11*one_line.get_height()/10))
            
        instream.close()
        
        continue_text = self.cont_font.render('Press SPACE to continue...',1,Color('Red'))
        self.image.blit(continue_text,(self.rect.width/20,self.rect.height-continue_text.get_height()))

    def update(self):
        scale = getScaling()
        if self.rect.width != int(scale*BASE_WIDTH):
            self.updateRect()
            self.image = Surface((self.rect.width,self.rect.height))
            self.image.convert_alpha()
            self.image.fill(self.bkgdcolor)
            self.image.set_alpha(200)
            self.drawText()
            self.updatenow = False