# Elevate
# Copyright 2007 Jeff Armstrong (jba@member.fsf.org) 
# 
# This program is free software; you can redistribute it and/or modify 
# it under the terms of the GNU General Public License as published by 
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version. 
#  
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to:
# Free Software Foundation, Inc.
# 51 Franklin Street, Fifth Floor
# Boston, MA  02110-1301, USA

import pygame
from pygame import *

from constants import *

RGBScales = []

def getUnscaledFloorHeight():
    true_height = BASE_HEIGHT-TOP_BUFFER-BOTTOM_BUFFER
    return true_height/NUMBER_FLOORS

def getFloorHeight():
    return int(getScaling()*getUnscaledFloorHeight())

def calculateFloorY(number):
    incr = getUnscaledFloorHeight()
    return int(getScaling()*((NUMBER_FLOORS-(number-1))*incr+BOTTOM_BUFFER))
    
def calculateFloorX():
    unscaled = GAME_WIDTH - int(getUnscaledFloorHeight()*ELEV_WIDTH_MULTIPLE)
    return int(getScaling()*unscaled)

def getAllFloorY():
    ys = []
    for i in range(0,NUMBER_FLOORS):
        ys.append(calculateFloorY(i+1))
    return ys

def getScaling():
    return SCALING

def fillBkgd(screen):
    background = pygame.Surface(screen.get_size())
    background = background.convert()
    background.fill(Color('White'))
    return background

def checkColor(value):
    value = max(value,0)
    value = min(value,255)
    return value

def preComputeRGBScaling():
    for x in range(0,110):
        RGBScales.append(getRGBScaling_Calced(x))

def getRGBScaling_Lookup(percent):
    return RGBScales[int(percent)]

def getRGBScaling_Calced(percent):
    red = 255
    green = 255
    if percent <= 50:
        red = checkColor((red*percent)/50)
    else:
        green = checkColor((green*(100-percent))/50)
    
    return (red,green,0)
    
def getRGBScaling(percent):
    if len(RGBScales) > 0:
        return getRGBScaling_Lookup(percent)
    else:
        return getRGBScaling_Calced(percent)
